import { CallOptions, RSA, RSN, SharedParameters } from "./utils";
import type { Path, Validate } from "./validate";
export declare type Guard<Name extends string, Type, Options extends RSA = RSN> = Validate<Name, Type, Options, false>;
export declare type GuardOptions<Name extends keyof vality.guards, G = vality.guards[Name]> = G extends Guard<any, infer Type, infer Options> | ((...args: any[]) => Guard<any, infer Type, infer Options>) ? [Type, Options] : never;
export declare type GuardFn<Type, Options> = (value: unknown, options: Partial<CallOptions<Type, Options>>, path: Path, parent?: any) => Type | undefined;
export declare function guard<Name extends keyof vality.guards, Type extends GuardOptions<Name>[0], Options extends RSA & GuardOptions<Name>[1]>(...[name, guardFn, handleOptions, defaultOptions]: SharedParameters<Name, Type, Options, GuardFn<Type, Options>>): Validate<Name, Type, Options, false>;
