"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = void 0;
const symbols_1 = require("./symbols");
const utils_1 = require("./utils");
const vality_1 = require("./vality");
function validate(schema, val, bail = false) {
    if (typeof schema === "function" && !(symbols_1._validate in schema))
        schema = vality_1.vality.object(schema())(bail === true ? { bail } : {});
    return (0, utils_1.enyToGuardFn)(schema)(val, [], undefined);
}
exports.validate = validate;
