import { Eny, IntersectItems, OneOrEnumOfTOrFace } from "./utils";
import { Face } from "./validate";
declare global {
    namespace vality {
        interface Config {
        }
    }
}
export declare type RelationType = vality.Config extends {
    RelationType: infer R;
} ? R : number | null;
declare type DecD<D> = "in-layer-one" extends D ? "in" : D;
export declare type Parse<T, _D = "out"> = T extends Face<"tuple", infer U, any> ? {
    [K in keyof U]: Parse<U[K], DecD<_D>>;
} : T extends Face<"and", infer U extends Eny[], true> ? IntersectItems<U> : T extends Face<"dict", [
    infer K extends OneOrEnumOfTOrFace<string | number>,
    infer V
], true> ? {
    [KK in Parse<K, DecD<_D>>]: Parse<V, DecD<_D>>;
} : T extends readonly [infer U] ? Parse<U, DecD<_D>>[] : T extends readonly (infer U)[] ? Parse<U, DecD<_D>> : T extends Face<"readonly", infer U, true> ? Parse<U, DecD<_D>> : T extends Face<any, infer U, true> ? Parse<U, DecD<_D>> : T extends Face<any, infer U, false> ? U : T extends () => infer U ? "in-layer-one" extends _D ? Parse<U, "in"> : "in" extends _D ? RelationType : Parse<U, _D> : {
    -readonly [K in keyof T as Parse<T[K], _D> extends never ? never : K]: Parse<T[K], DecD<_D>>;
};
export declare type ParseOut<T> = Parse<T>;
export declare type ParseIn<T> = Parse<T, "in-layer-one">;
export {};
